import python_common.edns.edns as edns
import sys
import time
import dns.resolver
import random
import math
import matplotlib.pyplot as plt
import numpy as np

def plt_censors_result(mean_list,std_list,label_xaxis,name):
	n_groups = 6
	index = np.arange(n_groups)
	bar_width = 0.6

	opacity = 0.4
	error_config = {'ecolor': 'k'}

	plt.bar(index, mean_list, bar_width, alpha=opacity, color='0.75', yerr=std_list, error_kw=error_config)
	plt.xlabel(label_xaxis)
	plt.ylabel('Change in DNS Responses')
	#plt.title('Scores by group and gender')
	plt.xticks(index + bar_width/2, ('1', '2', '3', '4', '5', 'DNS-sly'))
	#plt.legend()

	plt.tight_layout()
	plt.savefig(name, bbox_inches='tight')
	plt.show()

def get_entropy(ip_set1 , ip_set2):
	matches = 0
	if len(ip_set1) == len(ip_set2):
		print "Length is same"
		print "ip_set1 : ", ip_set1
		print "ip_set2 : ", ip_set2
		print "length : " , len(ip_set1)
		for i in range(0,len(ip_set1)):
			if ip_set1[i] == ip_set2[i]:
				matches +=1
		change = abs(float(1) - float(matches)/float(len(ip_set1)))
		print "change is : ", change
	else:
		print "Length is not the same"
		if len(ip_set1) < len(ip_set2):
			print "ip_set1 : ", ip_set1
			print "ip_set2 : ", ip_set2
			print "length : ", len(ip_set2)
			for i in range(0,len(ip_set1)):
				if ip_set1[i] == ip_set2[i]:
					matches += 1
			change = abs(float(1) - float(matches)/float(len(ip_set2)))
			print "change is: ", change
		else:
			print "ip_set1 : ", ip_set1
			print "ip_set2 : ", ip_set2
			print "length: ", len(ip_set1)
			for i in range(0,len(ip_set2)):
				if ip_set1[i] == ip_set2[i]:
					matches += 1
			change = abs(float(1) - float(matches)/float(len(ip_set1)))
			print "change is : ", change 
	return change

def build_and_send_query_edns0(filename,resolver_list):
	my_resolver = dns.resolver.Resolver()
	ans=[] #set of unique IPs for every domain
	my_resolver.timeout=0.5
	list_sets=[] #list of IPs for all domains 
	#r="146.115.108.186"
	arecord_list=[]
	domain_resolver_list =[]
	domain_list = []
	count = 0
	with open(filename) as name_f:
		for line in name_f:
			count += 1
			col = line.split()
			if 'akamai' in col[0] or 'akamai' not in col[0]:
				host_name = col[0]
				print "#############################HOSTNAME##############################################,", host_name
				for r in resolver_list:
					print "for resolver : ", r
					my_resolver.nameservers = [r]
					try:
						res = my_resolver.query(host_name,'A')
						for rdata in res:
							ans.append(rdata)
							print rdata
						domain_resolver_list.append(ans)
						ans=[]
					except dns.exception.Timeout:
					# Bad things
						print "Error: dns.exception.Timeout"
						continue
					except dns.resolver.NoAnswer:
						print "Error: dns.resolver.NoAnswer"
						continue
					except dns.resolver.NoNameservers:
						print "Error: dns.resolver.NoNameservers "
						continue
					except dns.resolver.NXDOMAIN:
						print "dns.resolver.NXDOMAIN"
						continue
			domain_list.append(domain_resolver_list)
			domain_resolver_list = []
			if count == 426:
				break
	#print domain_list
	return domain_list

def build_and_send_query_edns1(filename):
	r="146.115.108.186"
	GOOGLE = "8.8.8.8"
	ans=[]
	with open(filename) as name_f:
		for line in name_f:
			col = line.split()
			if 'akamai' in col[0] or 'akamai' not in col[0]:
				host_name = col[0]
				resp = edns.do_query(GOOGLE,host_name,"131.179.150.72",32,1)
				print resp
	print resp['records'][0].split()[-1]
	print len(resp['records'])
	for i in range(0,len(resp['records'])):
		ans.append(resp['records'][i].split()[-1])
	print ans
	return ans 

if __name__ == "__main__":
	# [NY, boston, LA, texas, chicago]
	resolver_list = ['170.171.11.33', '146.115.108.186', '192.208.232.180', '201.151.254.71', '64.94.33.33']
	domain_list = build_and_send_query_edns0("encoding_domains",resolver_list)
	print len(domain_list)
	#build_and_send_query_edns1("domain_file")
	resolver_biglist = []
	ldns_domain_list = []
	ldns_file = open("ldns_response" , "r")

	#make a domain list for LDNS:
	for line in ldns_file:
		line.strip("\n")
		col = line.split()
		ldns_domain_list.append(col)
	#done

	change_list = []
	#FOR FIRST DOMAIN
	j=0
	while j < len(domain_list[0]): # actually going over resolvers
		k=0
		while k < len(domain_list[0]):
			if j!=k:
				change_list.append(get_entropy(domain_list[0][j] , domain_list[0][k])) # for one resolver- change with all other resolvers (4 values)
			else:
				print "=====indices same======"
			k += 1
		resolver_biglist.append(change_list)
		change_list = []
		print "DOING FOR FIRST DOMAIN"
		print "resolver_biglist right now : ", resolver_biglist
		print len(resolver_biglist)
		j += 1 

	# FOR ALL OTHER  DOMAINS
	for i in range(1,len(domain_list)):
		print "i: ", i
		j=0
		while j < len(domain_list[i]): # actually going over resolvers
			print "j: ", j
			k=0
			print "length of resolver_biglist[j] before : ", len(resolver_biglist[j])
			while k < len(domain_list[i]):
				print "k: ", k
				if j!=k:
					resolver_biglist[j].append(get_entropy(domain_list[i][j] , domain_list[i][k])) # for one resolver- change with all other resolvers (4 values)
				else:
					print "=====indices same======"
				k += 1
			print  "length of resolver_biglist[j] after : ", len(resolver_biglist[j])
			j += 1 
	print "FINAL LENGHT OF RESOLVER_BIGLIST: ", len(resolver_biglist)
	print len(resolver_biglist[0])
	print resolver_biglist

	# GETTING DATA FOR JUST THE 5 resolvers 
	mean_list_resolvers = []
	std_list_resolvers = []
	for r in range(0,len(resolver_biglist)):
		mean_list_resolvers.append(np.mean(resolver_biglist[r]))
		std_list_resolvers.append(np.std(resolver_biglist[r]))
	print "MEAN LIST: ", mean_list_resolvers
	print "STD DEV LIST: ", std_list_resolvers
	#plt_censors_result(mean_list_resolvers,std_list_resolvers," Resolver ","censor_result.eps")


	#calculating change between each resolver and LDNS*#---------------------------------------------------------------------------------------------------
	text_ip = []
	domain_text_ip = []
	total_domains_textip = []

	for i in range(0,len(domain_list)):
		print "i : ", i
		j = 0 
		while j < len(domain_list[i]):
			print "j: ", j
			k=0
			while k < len(domain_list[i][j]):
				print "k: ", k
				resp=domain_list[i][j][k].to_text()
				print "resp ", resp
				text_ip.append(resp)
				k+=1
			domain_text_ip.append(text_ip)
			text_ip= []
			j += 1
		total_domains_textip.append(domain_text_ip)
		domain_text_ip = []
	print "****************************************************************************"
	#print total_domains_textip
	print len(total_domains_textip)
	print len(total_domains_textip[0])
	print "****************************************************************************"
	print "==================================================================================================================================="
	ldns_change_list = []
	for i in range(0,len(total_domains_textip)):
		print "i : ", i
		j = 0 
		#print "len before adding: ", len(ldns_change_list)
		while j < len(total_domains_textip[i]):
			#print "j: ", j
			ldns_change_list.append(get_entropy(ldns_domain_list[i], total_domains_textip[i][j]))
			#print "change_list is : " , change_list
			j += 1
		#print "len before adding: ", len(ldns_change_list)
	#print ldns_change_list
	print len(ldns_change_list)
	ldns_mean = np.mean(ldns_change_list)
	ldns_std = np.std(ldns_change_list)
	print ldns_mean
	print ldns_std
	mean_list_resolvers.append(ldns_mean)
	std_list_resolvers.append(ldns_std)
	print "FINAL MEAN LIST: ", mean_list_resolvers
	print "FINAL STD LIST: ", std_list_resolvers
	plt_censors_result(mean_list_resolvers,std_list_resolvers," Resolver ","censor_result.eps")


