#!/usr/bin/python
import socket
import sys
import dns
from dns.exception import DNSException
from dns.rdataclass import *
from dns.rdatatype import *
from dns.message import *
from dns.query import *
import encoding
import json
from random import randint
import math 
#import matplotlib.pyplot as plt
#import numpy as np

DOMAIN_DICT={}

UDP_IP = "127.0.0.1"


def plt_of_clicks(y_vals,label_xaxis,name):
    # Plot a cdf of object tput for each time epoch
    n_gropus=len(y_vals) 
    x_vals = np.arange(n_gropus)
    print x_vals
    fig = plt.figure(figsize=(6,3))
    plt.xlabel(label_xaxis)
    plt.ylabel("Number of Bytes per Click") 

    plt.plot(x_vals, y_vals, label="IP mapping", lw=2, color='k')

    plt.savefig(name, bbox_inches='tight')
    plt.show()

def plt_of_clicks_cumu(y_vals,label_xaxis,name):
    # Plot a cdf of object tput for each time epoch
    n_gropus=len(y_vals) 
    x_vals = np.arange(n_gropus)
    print x_vals
    fig = plt.figure(figsize=(6,3))
    plt.xlabel(label_xaxis)
    plt.ylabel("Cumulative Bytes") 

    plt.plot(x_vals, y_vals, label="IP mapping", lw=2, color='k')

    plt.savefig(name, bbox_inches='tight')
    plt.show()

def get_cummulative(byte_count):
    finalsum_list=[]
    cumu_sum=0
    for i in range(0,len(byte_count)):
        index=i
        while index >=0 :
            print "index : ",index
            print "byte_count[index]" , byte_count[index]
            cumu_sum += byte_count[index] # number of ips at the current time 
            print "cumu_sum", cumu_sum
            index=index-1
        finalsum_list.append(cumu_sum)
        cumu_sum = 0
    print finalsum_list
    return finalsum_list
    
def __getitem__(self, i):         
    return self.items[i] 

def init_domain_dict(filename):
    global DOMAIN_DICT

    ##### TODO: load it
    with open(filename) as data_file:    
        DOMAIN_DICT = json.load(data_file)

def make_list(filename):
    f_name=open(filename,'r')
    content_list=[]
    for line in f_name:
        col=line.split()
        content_list.append(col[0])
    f_name.close()
    return content_list

def build_and_send_query(domain):
    
    #data = "www.google.com" # buffer size is 1024 bytes
    data = domain
    list_ip=[]
    string=""
    # How many A records in a response (length)
    length = int (DOMAIN_DICT[data][0])
    # Determine the IP set size (base)
    base = len(DOMAIN_DICT[data][1])
    # Make a generic query and send it
    query = dns.message.make_query(data, dns.rdatatype.ANY, dns.rdataclass.IN)
    #query.flags+=dns.flags.TC
    print query
 
    response=dns.query.udp(query,UDP_IP,port=35353)
    print "================================"
    print response

    print "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$"
    print response.answer
    print "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$"

    text_resp = response.answer[0].to_text()
    for line in text_resp.split('\n'):
        record = line.split()[-1]
        print record
        print "----"
        list_ip.append(record)

    print list_ip
    """
    for ip in list_ip:
        ldns_file.write(ip + " ")
    ldns_file.write("\n")
    """

    #convert ips to index in dict
    list_index=[]
    for ip in list_ip:
        for j in range(0,base):
            col= DOMAIN_DICT[data][1][j].split("\n")
            if str(col[0])==str(ip):
                list_index.append(j)

    print "list of indices ", list_index 

    #decode the response
    string += encoding.decode(list_index, length, base)
    print "secret message:", string
    #print "ASCIII VALUE:", ord(string)
    return string

if __name__ == "__main__":
    message= "Hello Worldddddddddddfgfhjgjhkjhkjkljlklklppoiihjhf!"
    string=""
    sock = socket.socket(socket.AF_INET, # Internet
                          socket.SOCK_DGRAM) # UDP
    init_domain_dict('dict_final.json')
    seeddomain_list=make_list("alexa.txt")
    print seeddomain_list
    flag = 1
    ldns_file = open("ldns_response" , "w")
    totalbyte_curr_seed = 0
    byte_count = []
    byte_count.append(0)
    while flag > 0:
        index = randint(0,len(seeddomain_list)-1)
        domain = seeddomain_list[index]
        #domain = "google.fr"
        ext_domain = make_list("seed_"+domain)
        count=0
        
        while count < len(ext_domain):
            # calculate bytes you would get for this 
            length = int (DOMAIN_DICT[ext_domain[count]][0])

            # Determine the IP set size (base)
            base = base = len(DOMAIN_DICT[ext_domain[count]][1])

            data_chunk_bit = int(math.floor(math.log(base**length, 2)))
            data_chunk_byte = data_chunk_bit / 8
            totalbyte_curr_seed += data_chunk_byte
            if data_chunk_byte > 0: 
                string+=build_and_send_query(ext_domain[count])
            else:
                print "no byte would be encoded.... so not sending request"
            print "***** string in constrcution *****" , string
            print "LENGHT OF STRING IS : " , len(string)  
            if len(string) >= 3666 #1793016: #9465522: #3666:
                print "COMING HERE AND IGNORING ITTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT"
                flag = -1
                break
            count=count+1
        byte_count.append(totalbyte_curr_seed)
        totalbyte_curr_seed = 0

    #build_and_send_query("stackoverflow.com.")
    # changes for censor experiment
    print "==============================================================" 
    print "bytes_per_click: "
    print byte_count
    print len(byte_count)
    print "=============================================================="
    finalsum_list = get_cummulative(byte_count)
    print "cumulative_list ", finalsum_list
    #plt_of_clicks(byte_count,"Clicks", "bytes_perclick_experiment.eps")
    #plt_of_clicks_cumu(finalsum_list,"Clicks", "cumulative_bytes_perclick.eps")
    """
    fopen = open("encoding_domains" , "r")
    count = 0
    for line in fopen:
        domain = line.strip("\n")
        string += build_and_send_query(domain, ldns_file)
        print "***** string in constrcution *****" , string
        print "LENGHT OF STRING IS : " , len(string)
        count += 1
        if count == 426:
            break
    """
