import socket
import sys
import encoding
import dns
from dns.exception import DNSException
from dns.rdataclass import *
from dns.rdatatype import *
from dns.message import *
from dns.query import *
import json
from collections import defaultdict
# Where to listen for incoming IPs
UDP_IP = "127.0.0.1"
UDP_PORT = 35353

# Back end DNS stuff
BE_DNS = "8.8.8.8"
BE_PORT = 53

DOMAIN_DICT = {}

def byteify(input):
    if isinstance(input, dict):
        return {byteify(key):byteify(value) for key,value in input.iteritems()}
    elif isinstance(input, list):
        return [byteify(element) for element in input]
    elif isinstance(input, unicode):
        return input.encode('utf-8')
    else:
        return input

def init_domain_dict(filename):

    global DOMAIN_DICT

    ##### TODO: load it
    with open(filename) as data_file:    
        DOMAIN_DICT = json.load(data_file)

   # DOMAIN_DICT = byteify(DOMAIN_DICT)



def is_enc_name(domain):
    """ Check if this is an encoding name """

    # TODO: Write!
    #not working

    if domain not in DOMAIN_DICT:
        print "False"
        return False
    else:
        print "True"
        return True

def make_message():
    string = ""
    fopen = open("file_kb.txt", "r")
    for line in fopen:
        string += line.strip("\n")
    #print string 
    print len(string)
    return string 

def is_same(choices):
    D = defaultdict(list)
    for i,item in enumerate(choices):
        D[item].append(i)
    D = {k:v for k,v in D.items() if len(v)>1}
    print "defaultdict is : ", D
    print "====================="
    return D

def remove_similar(choices):
    while True:
        D = is_same(choices)
        if len(D) > 0:
            print "similar indices found!!"
            for key in D:
                print "key : ", key
                i=1
                while i < len(D[key]): #for all indices except the first one increment the value by 1
                    print "*************ip_choices[D[key][i]]: *************** ", choices[D[key][i]]
                    choices[D[key][i]] += 1
                    i +=1 
            #D = defaultdict(list)
        else:
            break
    print choices
    return choices

def get_enc_answers(domain, message, response, r,ttl):
    """ Given a domain and a message, determine an rrset for the answer
    
        returns (message_remain, answer)
    """

    #DOMAIN_DICT = {} # XXX MAKE ME!

    # Look up the domain in our dictionary 

    # How many A records in a response (length)
    prev_choice = []
    length = int (DOMAIN_DICT[domain][0])
    print "LENGTH IS :", length
    # Determine the IP set size (base)
    base = len(DOMAIN_DICT[domain][1])
    # Call the encoding
    print "BASE IS: ", base
    choices, message_remain = encoding.encode_chunk(message, length, base)
    print "choices", choices
    for c in choices:
        prev_choice.append(c) 

    new_choices=remove_similar(choices)

    #check if some index is out of bound
    for i in range(0,len(new_choices)):
        num = base -1 
        print "length of ipset: ", base
        if new_choices[i] > num:
            print "OUTBOUNDDDDDDDDDDDDDDDDDDDDD!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
            
            diff = new_choices[i]-num
            new_choices[i] = new_choices[i] - diff

    # Convert choices to an IP list
    ip_choices = [DOMAIN_DICT[domain][1][i] for i in new_choices]
    # Convert to rrset
    # TODO: Fix TTL
    # TODO: Copy from response
    print "ip_choices: ", ip_choices
    print "LENGHT OF IP_CHOICES", len(ip_choices)
    for i in range (0,len(ip_choices)):
        rrset = dns.rrset.from_text(domain, ttl, dns.rdataclass.IN,
                                    dns.rdatatype.A, str(ip_choices[i]))
        r.answer.append(rrset)

    return message_remain, r

def run_server():
    """ Run the infinite loop that is the server """
    sock = socket.socket(socket.AF_INET, # Internet
                          socket.SOCK_DGRAM) # UDP
    sock.bind((UDP_IP, UDP_PORT))

    init_domain_dict('dict_final.json')

    print "Before the loop"

    #message = "Hello Worldddddddddddfgfhjgjhkjhkjkljlklklppoiihjhf!"
    message = make_message()
    res_flag = 1

    #global D
    #D = defaultdict(list) #structure for removing similar indices 
    while True:
        # Read data from the client
        data, addr = sock.recvfrom(1024) # buffer size is 1024 bytes

        # Get query ID
        inc_query_id = ord(data[0]) * 256 + ord(data[1])

        # Convert that data to a DNS message
        msg = dns.message.from_wire(data)
        inc_query = msg.question[0].name

        # Generate a request for the same question, send it to the BE DNS
        query = dns.message.make_query(inc_query, dns.rdatatype.ANY, dns.rdataclass.IN)

        print "query ", query
        print "==========================="
        # Get the answer from the BE DNS
        if res_flag == 1 :
            response=dns.query.udp(query, BE_DNS, port=BE_PORT,timeout = 0.5)
            res_flag = -1
        print "Response:"
        print response
        # Generate the skeleton reponse
        r = dns.message.make_response(msg, our_payload=512)
        # Put all the stuff in it?
        r.id = inc_query_id
        r.flags = response.flags
        r.set_rcode(response.rcode())
        r.set_opcode(response.opcode())
        r.authority = response.authority
        r.fudge=response.fudge
        ttl = response.fudge
        # Build our answer set
        #if is_enc_name(inc_query):
        
        if is_enc_name(str(inc_query)):
            message, r = get_enc_answers(str(inc_query), message, response, r,ttl) # TODO: Instead of echoing, build a real set...
        else:
            r.answer = response.answer 

        #   Sent the response to the client
        wire_response = r.to_wire()
        sock.sendto(wire_response, addr)


if __name__ == "__main__":
    run_server()
